Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!

Bug 863905

Summary: sys-fs/jfsutils-1.1.15-r1 fails to compile (lto): log_work.c:329:16: error: type of ‘afterdata’ does not match original declaration [-Werror=lto-type-mismatch]
Product: Gentoo Linux Reporter: Agostino Sarubbo <ago>
Component: Current packagesAssignee: No maintainer - Look at https://wiki.gentoo.org/wiki/Project:Proxy_Maintainers if you want to take care of it <maintainer-needed>
Status: RESOLVED FIXED    
Severity: normal CC: eschwartz93
Priority: Normal    
Version: unspecified   
Hardware: All   
OS: Linux   
Whiteboard:
Package list:
Runtime testing required: ---
Bug Depends on:    
Bug Blocks: 618550    
Attachments: build.log

Description Agostino Sarubbo gentoo-dev 2022-08-06 06:22:42 UTC
https://blogs.gentoo.org/ago/2020/07/04/gentoo-tinderbox/

Issue: sys-fs/jfsutils-1.1.15-r1 fails to compile (lto).
Discovered on: amd64 (internal ref: lto_tinderbox)

NOTE:
This machine uses lto with CFLAGS=-flto -Werror=odr -Werror=lto-type-mismatch -Werror=strict-aliasing

Here is a bit of explanation:

-Werror=lto-type-mismatch:
User to find possible runtime issues in packages. It likely means the package is unsafe to build & use with LTO.
For projects using the same identifier but with different types across different files, they must be fixed to be consistent across the codebase.

-Werror=odr:
Used to find possible runtime issues in packages. These bugs are a problem anyway but may be even worse when combined with LTO. C++ code must comply with the One Definition Rule (ODR) - see https://en.cppreference.com/w/cpp/language/definition#One_Definition_Rule.

-Werror=strict-aliasing:
Used to find possible runtime issues in packages. These bugs are a problem anyway but may be even worse when combined with LTO.

Workarounds:
- If upstream is friendly and still active, file a bug upstream. For emulators, codecs, games, or multimedia packages, it may be worth just applying a workaround instead, as upstreams sometimes aren't receptive to these bugs (VALID FOR ALL).
- Use the new 'filter-lto' from flag-o-matic.eclass as it's likely to be unsafe with LTO (VALID FOR lto-type-mismatch - odr).
- Fix it yourself if interested, of course (VALID FOR ALL).
- Append-flags -fno-strict-aliasing (VALID FOR strict-aliasing).
- Use memcpy() but a union is sometimes suitable too (VALID FOR strict-aliasing).
- -fstrict-aliasing is implied by -O2, so this must be addressed in some form (VALID FOR strict-aliasing).

See also: https://marc.info/?l=gentoo-dev&m=165639574126280&w=2
Comment 1 Agostino Sarubbo gentoo-dev 2022-08-06 06:22:44 UTC
Created attachment 798148 [details]
build.log

build log and emerge --info
Comment 2 Eli Schwartz 2024-02-29 01:37:23 UTC
Note the original bug report appears to be broken, as that error doesn't appear in the uploaded log and the project has no such file.

It isn't a  strict-aliasing bug, "just" a lto-type-mismatch one.

x86_64-pc-linux-gnu-gcc  -march=native -fstack-protector-all -O2 -pipe -fdiagnostics-color=always -frecord-gcc-switches -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3 -fstack-clash-protection -flto=4 -Werror=odr -Werror=lto-type-mismatch -Werror=strict-aliasing  -Wformat -Werror=format-security -Werror=implicit-function-declaration -Werror=implicit-int -Werror=int-conversion -Werror=incompatible-pointer-types  -Wl,-O1 -Wl,--as-needed -flto=4 -Werror=odr -Werror=lto-type-mismatch -Werror=strict-aliasing -Wl,--defsym=__gentoo_check_ldflags__=0 -o jfs_fsck fsckbmap.o fsckconn.o fsckdire.o fsckdtre.o fsckea.o fsckimap.o fsckino.o fsckmeta.o fsckpfs.o dirindex.o fsckwsp.o fsckxtre.o xchkdsk.o fsckruns.o fsck_message.o ../libfs/libfs.a -luuid 
../libfs/log_work.c:329:16: error: type of ‘afterdata’ does not match original declaration [-Werror=lto-type-mismatch]
  329 | extern uint8_t afterdata[LOGPSIZE];     /* buffer to read in redopage data */
      |                ^
../libfs/log_dump.c:149:9: note: array types have different bounds
  149 | uint8_t afterdata[LOGPSIZE * 2];        /* buffer to read in redopage data */
      |         ^
../libfs/log_dump.c:149:9: note: ‘afterdata’ was previously declared here
lto1: some warnings being treated as errors
lto-wrapper: fatal error: x86_64-pc-linux-gnu-gcc returned 1 exit status
compilation terminated.
/usr/lib/gcc/x86_64-pc-linux-gnu/13/../../../../x86_64-pc-linux-gnu/bin/ld: error: lto-wrapper failed
collect2: error: ld returned 1 exit status
Comment 3 Larry the Git Cow gentoo-dev 2024-02-29 01:52:01 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=659b603bdae9200495a7a8e704e407ee53433552

commit 659b603bdae9200495a7a8e704e407ee53433552
Author:     Eli Schwartz <eschwartz93@gmail.com>
AuthorDate: 2024-02-29 01:31:15 +0000
Commit:     Sam James <sam@gentoo.org>
CommitDate: 2024-02-29 01:50:12 +0000

    sys-fs/jfsutils: mark as LTO-unsafe
    
    Note: the filesystem is not a huge hit, and the utils package was last
    released in 2011. It uses CVS as its version control, on sourceforge!
    which means that it's been decommissioned in 2017 and there was no one
    left to migrate or something. Discussion lists are inactive except the
    one hooked into kernel.org, which is only used for discussing the kernel
    driver not the utils.
    
    It's not clear how to effectively report a utils issue, or what would
    happen if we did.
    
    Closes: https://bugs.gentoo.org/863905
    Signed-off-by: Eli Schwartz <eschwartz93@gmail.com>
    Signed-off-by: Sam James <sam@gentoo.org>

 sys-fs/jfsutils/jfsutils-1.1.15-r2.ebuild | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)